// More geo stuff
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _683
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _66_68
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _68;

layout(set = 0, binding = 1, std430) restrict readonly buffer _113_115
{
    uint _m0[];
} _115;

layout(set = 0, binding = 0, std140) uniform _206_208
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _208;

layout(set = 1, binding = 0, std140) uniform _256_258
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
} _258;

layout(set = 0, binding = 2, std430) restrict readonly buffer _471_473
{
    vec4 _m0[];
} _473;

layout(set = 0, binding = 3, std430) restrict readonly buffer _685_687
{
    _683 _m0[];
} _687;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1612_1614
{
    uint _m0[];
} _1614;

layout(set = 0, binding = 15, std140) uniform _1617_1619
{
    vec4 _m0[4096];
} _1619;

layout(set = 0, binding = 16, std140) uniform _1621_1623
{
    vec4 _m0[4096];
} _1623;

layout(set = 0, binding = 17, std140) uniform _1625_1627
{
    vec4 _m0[4096];
} _1627;

layout(set = 0, binding = 19, std140) uniform _1633_1635
{
    vec4 _m0[4096];
} _1635;

layout(set = 0, binding = 20, std140) uniform _1637_1639
{
    vec4 _m0[4096];
} _1639;

layout(set = 0, binding = 21, std140) uniform _1642_1644
{
    vec4 _m0[3072];
} _1644;

layout(set = 0, binding = 23, std140) uniform _1647_1649
{
    vec4 _m0[4095];
} _1649;

layout(set = 0, binding = 25, std140) uniform _1655_1657
{
    vec4 _m0[4096];
} _1657;

layout(push_constant, std430) uniform _81_83
{
    int _m0;
    int _m1;
} _83;

layout(set = 0, binding = 4) uniform sampler3D _1017;
layout(set = 0, binding = 5) uniform sampler3D _1096;
layout(set = 0, binding = 6) uniform sampler _1604;
layout(set = 0, binding = 7) uniform sampler _1605;
layout(set = 0, binding = 8) uniform sampler _1606;
layout(set = 0, binding = 9) uniform sampler _1607;
layout(set = 0, binding = 10) uniform sampler _1608;
layout(set = 0, binding = 11) uniform sampler _1609;
layout(set = 0, binding = 12) uniform sampler _1610;
layout(set = 0, binding = 18) uniform sampler2D _1631;
layout(set = 0, binding = 22) uniform sampler2D _1645;
layout(set = 0, binding = 24) uniform sampler2DShadow _1653;
layout(set = 0, binding = 26) uniform sampler2D _1658;
layout(set = 0, binding = 27) uniform sampler2D _1659;
layout(set = 1, binding = 1) uniform sampler2D _1660;
layout(set = 1, binding = 2) uniform sampler2D _1661;

layout(location = 15) out vec4 _154;
layout(location = 14) flat out uvec3 _162;
layout(location = 0) in vec4 _169;
layout(location = 2) in vec4 _177;
layout(location = 9) in vec4 _184;
layout(location = 3) in vec4 _241;
layout(location = 3) out vec4 _736;
layout(location = 4) out vec4 _760;
layout(location = 5) out vec4 _783;
layout(location = 6) out vec4 _829;
layout(location = 1) in vec2 _836;
layout(location = 12) in vec2 _838;
layout(location = 2) out vec4 _845;
layout(location = 10) out vec4 _857;
layout(location = 11) out vec4 _858;
layout(location = 12) out vec4 _859;
layout(location = 8) out vec4 _1213;

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

float _23(vec4 _21, vec4 _22)
{
    return dot(_21.xyz, _22.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

float _16(vec3 _14, vec3 _15)
{
    return dot(_14, _15);
}

void main()
{
    vec4 _54 = vec4(0.0);
    vec3 _56 = vec3(0.0);
    uvec2 _61 = uvec2(0u);
    uint _65 = 0u;
    if (_68._m0.x > 0.0)
    {
        int _79 = int(_68._m1[_83._m0]);
        int _90 = gl_VertexIndex & 16777215;
        int _96 = _90 + _79;
        uint _100 = uint(_96 / 2);
        uint _105 = uint(16 * (_96 & 1));
        uint _111 = _115._m0[_100] >> _105;
        _61.x = _111 & 7u;
        _61.y = (_111 >> uint(3)) & 7u;
        _56.x = float((_111 >> uint(6)) & 63u) / 63.0;
        _56.y = 0.0;
        _56.z = float((_111 >> uint(12)) & 15u) / 15.0;
    }
    _154 = vec4(_56, 0.0);
    _162 = uvec3(_61.x, _61.y, 0u);
    _54 = vec4(_169.xyz, 1.0);
    vec4 _176 = (_177 * 2.0) - vec4(1.0);
    vec4 _183 = (_184 * 2.0) - vec4(1.0);
    _183.w = (floor((_184.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    bool _203 = _68._m2.x != 0.0;
    bool _213;
    if (_203)
    {
        _213 = _208._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _213 = _203;
    }
    bool _219;
    if (_213)
    {
        _219 = _68._m3.x > 0.0;
    }
    else
    {
        _219 = _213;
    }
    if (_219)
    {
        vec3 _222 = vec3(_208._m0.xy, 0.0);
        float _231 = _68._m2.x;
        float _234 = _68._m2.y;
        float _237 = _68._m2.w;
        vec4 _240 = _241;
        float _243 = _68._m3.x;
        float _246 = _68._m3.y;
        float _249 = _68._m3.z;
        float _252 = _68._m3.w;
        vec4 _259 = _54;
        vec4 _261 = _258._m0;
        vec4 _255;
        _255.x = _27(_259, _261);
        vec4 _266 = _54;
        vec4 _268 = _258._m1;
        _255.y = _27(_266, _268);
        vec4 _273 = _54;
        vec4 _275 = _258._m2;
        _255.z = _27(_273, _275);
        _255.w = 1.0;
        float _281 = dot(_255.xyz, _222) * _243;
        float _288 = _240.z * _252;
        float _293 = _258._m0.w * _258._m1.w;
        float _299 = ((_208._m1.x * _68._m2.z) * _243) - _281;
        float _309 = (_240.x * 1.0) - _288;
        float _315 = sin(_299 - _309);
        float _320 = sin((_299 * 1.33000004291534423828125) - _309);
        float _327 = ((_315 + _320) * 0.25) + 0.5;
        _327 *= _327;
        float _338 = (_327 * (_234 - _231)) + _231;
        vec3 _346 = _222 * vec3(_338);
        float _351 = ((_240.y * 16.0) - _293) - _288;
        float _360 = sin(((_208._m1.x * 4.0) * _246) + _351);
        float _370 = cos(((_208._m1.x * 3.3299999237060546875) * _246) + _351);
        float _380 = (_360 + _370) * (-_240.w);
        vec3 _388 = vec3(_360 * _237, _370 * _237, _380 * _249) * vec3(_338);
        vec3 _402 = ((_346 + _388) * _208._m0.z) * _240.z;
        vec3 _415 = _255.xyz + _402;
        _255 = vec4(_415.x, _415.y, _415.z, _255.w);
        _255.w = 1.0;
        _54.x = dot(_255, _258._m3);
        _54.y = dot(_255, _258._m4);
        _54.z = dot(_255, _258._m5);
    }
    float _436 = 0.0;
    if (_68._m4.z != 0.0)
    {
        vec4 _442 = _54;
        vec4 _444 = vec4(0.0);
        vec4 _445 = vec4(0.0);
        vec4 _446 = vec4(0.0);
        uvec4 _449 = uvec4(uint(_258._m6.x + _68._m4.x)) + uvec4(_241 * 255.0);
        if (_68._m4.z == 1.0)
        {
            uint _467 = _449.x;
            _444 = _473._m0[(_467 * 3u) + 0u];
            _445 = _473._m0[(_467 * 3u) + 1u];
            _446 = _473._m0[(_467 * 3u) + 2u];
        }
        else
        {
            float _490 = _184.w * 255.100006103515625;
            vec4 _494;
            _494.y = _490 - (floor(_490 / 128.0) * 128.0);
            float _502 = _177.w * 255.100006103515625;
            _494.z = floor(_502 / 16.0);
            _494.w = _502 - (_494.z * 16.0);
            _494.y *= 0.00393700785934925079345703125;
            _494.z *= 0.02222222276031970977783203125;
            _494.w *= 0.01666666753590106964111328125;
            _494.x = 1.0 - ((_494.y + _494.z) + _494.w);
            for (uint _541 = 0u; _541 < 4u; _541++)
            {
                _444 += (_473._m0[(_449[_541] * 3u) + 0u] * _494[_541]);
            }
            for (uint _565 = 0u; _565 < 4u; _565++)
            {
                _445 += (_473._m0[(_449[_565] * 3u) + 1u] * _494[_565]);
            }
            for (uint _588 = 0u; _588 < 4u; _588++)
            {
                _446 += (_473._m0[(_449[_588] * 3u) + 2u] * _494[_588]);
            }
        }
        vec4 _611 = _442;
        vec4 _613 = _444;
        _54.x = _27(_611, _613);
        vec4 _617 = _442;
        vec4 _619 = _445;
        _54.y = _27(_617, _619);
        vec4 _623 = _442;
        vec4 _625 = _446;
        _54.z = _27(_623, _625);
        _54.w = 1.0;
        vec4 _630 = _176;
        vec4 _632 = _630;
        vec4 _634 = _444;
        _176.x = _23(_632, _634);
        vec4 _638 = _630;
        vec4 _640 = _445;
        _176.y = _23(_638, _640);
        vec4 _644 = _630;
        vec4 _646 = _446;
        _176.z = _23(_644, _646);
        vec4 _650 = _183;
        vec4 _652 = _650;
        vec4 _654 = _444;
        _183.x = _23(_652, _654);
        vec4 _658 = _650;
        vec4 _660 = _445;
        _183.y = _23(_658, _660);
        vec4 _664 = _650;
        vec4 _666 = _446;
        _183.z = _23(_664, _666);
    }
    vec3 _678 = cross(_176.xyz, _183.xyz) * _183.w;
    vec4 _670;
    _670 = vec4(_678.x, _678.y, _678.z, _670.w);
    _670.w = 0.0;
    vec4 _682 = _687._m0[_83._m1]._m0;
    vec4 _692 = _687._m0[_83._m1]._m1;
    vec4 _697 = _687._m0[_83._m1]._m2;
    vec4 _702 = _687._m0[_83._m1]._m3;
    vec4 _711 = _54;
    vec4 _713 = _682;
    gl_Position.x = _27(_711, _713);
    vec4 _718 = _54;
    vec4 _720 = _692;
    gl_Position.y = _27(_718, _720);
    vec4 _724 = _54;
    vec4 _726 = _697;
    gl_Position.z = _27(_724, _726);
    vec4 _730 = _54;
    vec4 _732 = _702;
    gl_Position.w = _27(_730, _732);
    vec4 _737 = _183;
    vec4 _739 = _258._m0;
    _736.x = _23(_737, _739);
    vec4 _744 = _670;
    vec4 _746 = _258._m0;
    _736.y = _23(_744, _746);
    vec4 _751 = _176;
    vec4 _753 = _258._m0;
    _736.z = _23(_751, _753);
    _736.w = _436;
    vec4 _761 = _183;
    vec4 _763 = _258._m1;
    _760.x = _23(_761, _763);
    vec4 _768 = _670;
    vec4 _770 = _258._m1;
    _760.y = _23(_768, _770);
    vec4 _775 = _176;
    vec4 _777 = _258._m1;
    _760.z = _23(_775, _777);
    _760.w = 0.0;
    vec4 _784 = _183;
    vec4 _786 = _258._m2;
    _783.x = _23(_784, _786);
    vec4 _791 = _670;
    vec4 _793 = _258._m2;
    _783.y = _23(_791, _793);
    vec4 _798 = _176;
    vec4 _800 = _258._m2;
    _783.z = _23(_798, _800);
    _783.w = 0.0;
    vec4 _807 = _54;
    vec4 _809 = _258._m0;
    vec4 _806;
    _806.x = _27(_807, _809);
    vec4 _814 = _54;
    vec4 _816 = _258._m1;
    _806.y = _27(_814, _816);
    vec4 _821 = _54;
    vec4 _823 = _258._m2;
    _806.z = _27(_821, _823);
    _806.w = 1.0;
    _829 = _806 - _208._m2;
    vec4 _834 = vec4(_836, _838);
    _845 = _834 + _68._m5;
    vec3 _850 = _829.xyz + _208._m2.xyz;
    _857 = vec4(0.0);
    _858 = vec4(0.0);
    _859 = vec4(0.0);
    float _860 = float(_208._m3.x > 0.0);
    float _865 = _208._m3.x * _258._m7.x;
    bool _875 = _208._m3.y > 0.0;
    bool _882;
    if (!_875)
    {
        _882 = _208._m3.z > 0.0;
    }
    else
    {
        _882 = _875;
    }
    bool _889;
    if (!_882)
    {
        _889 = _208._m3.w > 0.0;
    }
    else
    {
        _889 = _882;
    }
    float _872 = float(_889);
    vec3 _891 = vec3(0.579999983310699462890625) * _208._m3.yzw;
    _857 = vec4(_208._m3.y, _208._m3.z, _208._m3.w, _891.x);
    _858 = vec4(_891.y, _891.z, _891.x, _891.y);
    _859 = vec4(_891.z, _891.x, _891.y, _891.z);
    if ((_860 > 0.0) && (_872 <= 0.0))
    {
        float _932 = -4096.0;
        float _934 = 4096.0;
        float _936 = 256.0;
        float _938 = 256.0;
        float _939 = 6.0;
        float _941 = 256.0;
        float _942 = 256.0;
        float _943 = 24.0;
        vec3 _945 = vec3(1.0 / _941, 1.0 / _942, 1.0 / _943);
        vec3 _953 = vec3(2.0 / _941, 2.0 / _942, 2.0 / _943);
        vec3 _961 = vec3(1.0 / _936, 1.0 / _938, 1.0 / _939);
        float _969 = 1.0 / (_934 - _932);
        vec3 _981 = (_850 - vec3(_932)) * _969;
        vec3 _974 = _11(_981);
        vec4 _983 = vec4(0.0);
        uvec3 _985 = uvec3(0u);
        for (uint _987 = 0u; _987 < 13u; _987++)
        {
            vec3 _996 = vec3(0.5) + floor(vec3(2.0) * _974);
            vec4 _1003 = vec4(_961 * (vec3(_985) + _996), 0.0);
            _983 = textureLod(_1017, _1003.xyz, _1003.w);
            _974 = fract(_974 * vec3(2.0));
            _985 = uvec3(_983.zyx * vec3(255.0));
            if (_983.w > 0.0)
            {
                break;
            }
        }
        uint _1040 = (((uint(_983.w * 255.0) << uint(24)) | (uint(_983.z * 255.0) << uint(16))) | (uint(_983.y * 255.0) << uint(8))) | uint(_983.x * 255.0);
        uvec3 _1065 = uvec3((_1040 >> uint(19)) & 4095u, (_1040 >> uint(7)) & 4095u, _1040 & 127u);
        vec3 _1078 = vec3(2.0) * ((_974 * vec3(0.5)) + vec3(0.25));
        vec4 _1084 = vec4(_945 * (vec3(_1065) + _1078), 0.0);
        vec4 _1095 = textureLod(_1096, vec4(_1084.xy, _1084.z + (_953.z * 0.0), 0.0).xyz, vec4(_1084.xy, _1084.z + (_953.z * 0.0), 0.0).w) * _865;
        vec4 _1125 = textureLod(_1096, vec4(_1084.xy, _1084.z + (_953.z * 1.0), 0.0).xyz, vec4(_1084.xy, _1084.z + (_953.z * 1.0), 0.0).w) * _865;
        vec4 _1154 = textureLod(_1096, vec4(_1084.xy, _1084.z + (_953.z * 2.0), 0.0).xyz, vec4(_1084.xy, _1084.z + (_953.z * 2.0), 0.0).w) * _865;
        _857 = vec4(_1095.x, _1125.x, _1154.x, _1095.y);
        _858 = vec4(_1125.y, _1154.y, _1095.z, _1125.z);
        _859 = vec4(_1154.z, _1095.w, _1125.w, _1154.w);
    }
    vec3 _1210 = _169.xyz;
    _1213 = vec4(0.0);
    vec3 _1214 = (_258._m8.xyz - _1210) * _258._m8.w;
    vec3 _1223 = (_258._m9.xyz - _1210) * _258._m9.w;
    vec3 _1233 = (_258._m10.xyz - _1210) * _258._m10.w;
    vec3 _1243 = (_258._m11.xyz - _1210) * _258._m11.w;
    vec3 _1253 = (_258._m12.xyz - _1210) * _258._m12.w;
    vec3 _1262 = (_258._m13.xyz - _1210) * _258._m13.w;
    vec3 _1272 = (_258._m14.xyz - _1210) * _258._m14.w;
    vec3 _1282 = (_258._m15.xyz - _1210) * _258._m15.w;
    vec3 _1292 = (_258._m16.xyz - _1210) * _258._m16.w;
    vec3 _1301 = (_258._m17.xyz - _1210) * _258._m17.w;
    vec3 _1311 = (_258._m18.xyz - _1210) * _258._m18.w;
    vec3 _1321 = (_258._m19.xyz - _1210) * _258._m19.w;
    vec3 _1330 = (_258._m20.xyz - _1210) * _258._m20.w;
    vec3 _1340 = (_258._m21.xyz - _1210) * _258._m21.w;
    vec3 _1350 = (_258._m22.xyz - _1210) * _258._m22.w;
    vec3 _1360 = (_258._m23.xyz - _1210) * _258._m23.w;
    vec3 _1370 = (_258._m24.xyz - _1210) * _258._m24.w;
    vec3 _1379 = (_258._m25.xyz - _1210) * _258._m25.w;
    vec3 _1389 = (_258._m26.xyz - _1210) * _258._m26.w;
    vec3 _1399 = (_258._m27.xyz - _1210) * _258._m27.w;
    vec3 _1410 = _1214;
    vec3 _1412 = _1214;
    float _1409 = _16(_1410, _1412);
    vec3 _1416 = _1223;
    vec3 _1418 = _1223;
    float _1415 = _16(_1416, _1418);
    vec3 _1422 = _1233;
    vec3 _1424 = _1233;
    float _1421 = _16(_1422, _1424);
    vec3 _1428 = _1243;
    vec3 _1430 = _1243;
    float _1427 = _16(_1428, _1430);
    vec3 _1434 = _1253;
    vec3 _1436 = _1253;
    float _1433 = _16(_1434, _1436);
    vec3 _1440 = _1262;
    vec3 _1442 = _1262;
    float _1439 = _16(_1440, _1442);
    vec3 _1446 = _1272;
    vec3 _1448 = _1272;
    float _1445 = _16(_1446, _1448);
    vec3 _1452 = _1282;
    vec3 _1454 = _1282;
    float _1451 = _16(_1452, _1454);
    vec3 _1458 = _1292;
    vec3 _1460 = _1292;
    float _1457 = _16(_1458, _1460);
    vec3 _1464 = _1301;
    vec3 _1466 = _1301;
    float _1463 = _16(_1464, _1466);
    vec3 _1470 = _1311;
    vec3 _1472 = _1311;
    float _1469 = _16(_1470, _1472);
    vec3 _1476 = _1321;
    vec3 _1478 = _1321;
    float _1475 = _16(_1476, _1478);
    vec3 _1482 = _1330;
    vec3 _1484 = _1330;
    float _1481 = _16(_1482, _1484);
    vec3 _1488 = _1340;
    vec3 _1490 = _1340;
    float _1487 = _16(_1488, _1490);
    vec3 _1494 = _1350;
    vec3 _1496 = _1350;
    float _1493 = _16(_1494, _1496);
    vec3 _1500 = _1360;
    vec3 _1502 = _1360;
    float _1499 = _16(_1500, _1502);
    vec3 _1506 = _1370;
    vec3 _1508 = _1370;
    float _1505 = _16(_1506, _1508);
    vec3 _1512 = _1379;
    vec3 _1514 = _1379;
    float _1511 = _16(_1512, _1514);
    vec3 _1518 = _1389;
    vec3 _1520 = _1389;
    float _1517 = _16(_1518, _1520);
    vec3 _1524 = _1399;
    vec3 _1526 = _1399;
    float _1523 = _16(_1524, _1526);
    float _1529 = min(_1409, _1415);
    _1529 = min(_1529, _1421);
    _1529 = min(_1529, _1427);
    _1529 = min(_1529, _1433);
    _1529 = min(_1529, _1439);
    _1529 = min(_1529, _1445);
    _1529 = min(_1529, _1451);
    _1529 = min(_1529, _1457);
    _1529 = min(_1529, _1463);
    _1529 = min(_1529, _1469);
    _1529 = min(_1529, _1475);
    float _1563 = min(_1481, _1487);
    _1563 = min(_1563, _1493);
    _1563 = min(_1563, _1499);
    _1563 = min(_1563, _1505);
    _1563 = min(_1563, _1511);
    _1563 = min(_1563, _1517);
    _1563 = min(_1563, _1523);
    float _1585 = sqrt(min(_1529, _1563)) - 1.0;
    float _1591 = sqrt(_1529) - 1.0;
    _1213 = vec4(_1585, 0.0, 0.0, _1591);
    gl_Position.y = -gl_Position.y;

    // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


