// MORE GEOMOETRY
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _287
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _31_33
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _33;

layout(set = 0, binding = 0, std140) uniform _45_47
{
    vec4 _m0;
    vec4 _m1;
} _47;

layout(set = 1, binding = 0, std140) uniform _102_104
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _104;

layout(set = 0, binding = 1, std430) restrict readonly buffer _289_291
{
    _287 _m0[];
} _291;

layout(push_constant, std430) uniform _292_294
{
    int _m0;
    int _m1;
} _294;

layout(location = 0) in vec4 _21;
layout(location = 3) in vec4 _87;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    vec4 _19 = vec4(_21.xyz, 1.0);
    bool _42 = _33._m4.x != 0.0;
    bool _54;
    if (_42)
    {
        _54 = _47._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _54 = _42;
    }
    bool _61;
    if (_54)
    {
        _61 = _33._m5.x > 0.0;
    }
    else
    {
        _61 = _54;
    }
    if (_61)
    {
        vec3 _65 = vec3(_47._m0.xy, 0.0);
        float _75 = _33._m4.x;
        float _78 = _33._m4.y;
        float _82 = _33._m4.w;
        vec4 _86 = _87;
        float _89 = _33._m5.x;
        float _92 = _33._m5.y;
        float _95 = _33._m5.z;
        float _98 = _33._m5.w;
        vec4 _105 = _19;
        vec4 _107 = _104._m5;
        vec4 _101;
        _101.x = _12(_105, _107);
        vec4 _113 = _19;
        vec4 _115 = _104._m6;
        _101.y = _12(_113, _115);
        vec4 _121 = _19;
        vec4 _123 = _104._m7;
        _101.z = _12(_121, _123);
        _101.w = 1.0;
        float _129 = dot(_101.xyz, _65) * _89;
        float _136 = _86.z * _98;
        float _141 = _104._m5.w * _104._m6.w;
        float _147 = ((_47._m1.x * _33._m4.z) * _89) - _129;
        float _158 = (_86.x * 1.0) - _136;
        float _164 = sin(_147 - _158);
        float _169 = sin((_147 * 1.33000004291534423828125) - _158);
        float _176 = ((_164 + _169) * 0.25) + 0.5;
        _176 *= _176;
        float _187 = (_176 * (_78 - _75)) + _75;
        vec3 _195 = _65 * vec3(_187);
        float _200 = ((_86.y * 16.0) - _141) - _136;
        float _209 = sin(((_47._m1.x * 4.0) * _92) + _200);
        float _219 = cos(((_47._m1.x * 3.3299999237060546875) * _92) + _200);
        float _229 = (_209 + _219) * (-_86.w);
        vec3 _237 = vec3(_209 * _82, _219 * _82, _229 * _95) * vec3(_187);
        vec3 _251 = ((_195 + _237) * _47._m0.z) * _86.z;
        vec3 _264 = _101.xyz + _251;
        _101 = vec4(_264.x, _264.y, _264.z, _101.w);
        _101.w = 1.0;
        _19.x = dot(_101, _104._m13);
        _19.y = dot(_101, _104._m14);
        _19.z = dot(_101, _104._m15);
    }
    vec4 _286 = _291._m0[_294._m1]._m0;
    vec4 _300 = _291._m0[_294._m1]._m1;
    vec4 _305 = _291._m0[_294._m1]._m2;
    vec4 _311 = _291._m0[_294._m1]._m3;
    vec4 _321 = _19;
    vec4 _323 = _286;
    gl_Position.x = _12(_321, _323);
    vec4 _328 = _19;
    vec4 _330 = _300;
    gl_Position.y = _12(_328, _330);
    vec4 _334 = _19;
    vec4 _336 = _305;
    gl_Position.z = _12(_334, _336);
    vec4 _340 = _19;
    vec4 _342 = _311;
    gl_Position.w = _12(_340, _342);
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


