// BODY
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _679
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _56_58
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _58;

layout(set = 0, binding = 1, std430) restrict readonly buffer _103_105
{
    uint _m0[];
} _105;

layout(set = 0, binding = 0, std140) uniform _197_199
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _199;

layout(set = 1, binding = 0, std140) uniform _248_250
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _250;

layout(set = 0, binding = 2, std430) restrict readonly buffer _467_469
{
    vec4 _m0[];
} _469;

layout(set = 0, binding = 3, std430) restrict readonly buffer _681_683
{
    _679 _m0[];
} _683;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1218_1220
{
    uint _m0[];
} _1220;

layout(set = 0, binding = 15, std140) uniform _1223_1225
{
    vec4 _m0[4096];
} _1225;

layout(set = 0, binding = 16, std140) uniform _1227_1229
{
    vec4 _m0[4096];
} _1229;

layout(set = 0, binding = 17, std140) uniform _1231_1233
{
    vec4 _m0[4096];
} _1233;

layout(set = 0, binding = 19, std140) uniform _1239_1241
{
    vec4 _m0[4096];
} _1241;

layout(set = 0, binding = 20, std140) uniform _1243_1245
{
    vec4 _m0[4096];
} _1245;

layout(set = 0, binding = 21, std140) uniform _1248_1250
{
    vec4 _m0[3072];
} _1250;

layout(set = 0, binding = 23, std140) uniform _1253_1255
{
    vec4 _m0[4095];
} _1255;

layout(set = 0, binding = 25, std140) uniform _1261_1263
{
    vec4 _m0[4096];
} _1263;

layout(push_constant, std430) uniform _71_73
{
    int _m0;
    int _m1;
} _73;

layout(set = 0, binding = 4) uniform sampler3D _1012;
layout(set = 0, binding = 5) uniform sampler3D _1090;
layout(set = 0, binding = 6) uniform sampler _1210;
layout(set = 0, binding = 7) uniform sampler _1211;
layout(set = 0, binding = 8) uniform sampler _1212;
layout(set = 0, binding = 9) uniform sampler _1213;
layout(set = 0, binding = 10) uniform sampler _1214;
layout(set = 0, binding = 11) uniform sampler _1215;
layout(set = 0, binding = 12) uniform sampler _1216;
layout(set = 0, binding = 18) uniform sampler2D _1237;
layout(set = 0, binding = 22) uniform sampler2D _1251;
layout(set = 0, binding = 24) uniform sampler2DShadow _1259;
layout(set = 0, binding = 26) uniform sampler2D _1264;
layout(set = 0, binding = 27) uniform sampler2D _1265;

layout(location = 15) out vec4 _144;
layout(location = 14) flat out uvec3 _152;
layout(location = 0) in vec4 _159;
layout(location = 2) in vec4 _167;
layout(location = 9) in vec4 _174;
layout(location = 3) in vec4 _233;
layout(location = 3) out vec4 _732;
layout(location = 4) out vec4 _756;
layout(location = 5) out vec4 _779;
layout(location = 6) out vec4 _825;
layout(location = 1) in vec2 _832;
layout(location = 12) in vec2 _834;
layout(location = 2) out vec4 _841;
layout(location = 10) out vec4 _853;
layout(location = 11) out vec4 _854;
layout(location = 12) out vec4 _855;

float _22(vec4 _20, vec4 _21)
{
    return dot(_20, _21);
}

float _18(vec4 _16, vec4 _17)
{
    return dot(_16.xyz, _17.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

void main()
{
    vec4 _44 = vec4(0.0);
    vec3 _46 = vec3(0.0);
    uvec2 _51 = uvec2(0u);
    uint _55 = 0u;
    if (_58._m1.x > 0.0)
    {
        int _69 = int(_58._m2[_73._m0]);
        int _81 = gl_VertexIndex & 16777215;
        int _87 = _81 + _69;
        uint _91 = uint(_87 / 2);
        uint _95 = uint(16 * (_87 & 1));
        uint _101 = _105._m0[_91] >> _95;
        _51.x = _101 & 7u;
        _51.y = (_101 >> uint(3)) & 7u;
        _46.x = float((_101 >> uint(6)) & 63u) / 63.0;
        _46.y = 0.0;
        _46.z = float((_101 >> uint(12)) & 15u) / 15.0;
    }
    _144 = vec4(_46, 0.0);
    _152 = uvec3(_51.x, _51.y, 0u);
    _44 = vec4(_159.xyz, 1.0);
    vec4 _166 = (_167 * 2.0) - vec4(1.0);
    vec4 _173 = (_174 * 2.0) - vec4(1.0);
    _173.w = (floor((_174.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    bool _194 = _58._m4.x != 0.0;
    bool _204;
    if (_194)
    {
        _204 = _199._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _204 = _194;
    }
    bool _211;
    if (_204)
    {
        _211 = _58._m5.x > 0.0;
    }
    else
    {
        _211 = _204;
    }
    if (_211)
    {
        vec3 _214 = vec3(_199._m0.xy, 0.0);
        float _223 = _58._m4.x;
        float _226 = _58._m4.y;
        float _229 = _58._m4.w;
        vec4 _232 = _233;
        float _235 = _58._m5.x;
        float _238 = _58._m5.y;
        float _241 = _58._m5.z;
        float _244 = _58._m5.w;
        vec4 _251 = _44;
        vec4 _253 = _250._m5;
        vec4 _247;
        _247.x = _22(_251, _253);
        vec4 _258 = _44;
        vec4 _260 = _250._m6;
        _247.y = _22(_258, _260);
        vec4 _266 = _44;
        vec4 _268 = _250._m7;
        _247.z = _22(_266, _268);
        _247.w = 1.0;
        float _274 = dot(_247.xyz, _214) * _235;
        float _281 = _232.z * _244;
        float _286 = _250._m5.w * _250._m6.w;
        float _292 = ((_199._m1.x * _58._m4.z) * _235) - _274;
        float _302 = (_232.x * 1.0) - _281;
        float _308 = sin(_292 - _302);
        float _313 = sin((_292 * 1.33000004291534423828125) - _302);
        float _320 = ((_308 + _313) * 0.25) + 0.5;
        _320 *= _320;
        float _331 = (_320 * (_226 - _223)) + _223;
        vec3 _339 = _214 * vec3(_331);
        float _344 = ((_232.y * 16.0) - _286) - _281;
        float _353 = sin(((_199._m1.x * 4.0) * _238) + _344);
        float _363 = cos(((_199._m1.x * 3.3299999237060546875) * _238) + _344);
        float _373 = (_353 + _363) * (-_232.w);
        vec3 _381 = vec3(_353 * _229, _363 * _229, _373 * _241) * vec3(_331);
        vec3 _395 = ((_339 + _381) * _199._m0.z) * _232.z;
        vec3 _408 = _247.xyz + _395;
        _247 = vec4(_408.x, _408.y, _408.z, _247.w);
        _247.w = 1.0;
        _44.x = dot(_247, _250._m13);
        _44.y = dot(_247, _250._m14);
        _44.z = dot(_247, _250._m15);
    }
    float _430 = 0.0;
    if (_58._m8.z != 0.0)
    {
        vec4 _437 = _44;
        vec4 _439 = vec4(0.0);
        vec4 _440 = vec4(0.0);
        vec4 _441 = vec4(0.0);
        uvec4 _444 = uvec4(uint(_250._m21.x + _58._m8.x)) + uvec4(_233 * 255.0);
        if (_58._m8.z == 1.0)
        {
            uint _463 = _444.x;
            _439 = _469._m0[(_463 * 3u) + 0u];
            _440 = _469._m0[(_463 * 3u) + 1u];
            _441 = _469._m0[(_463 * 3u) + 2u];
        }
        else
        {
            float _486 = _174.w * 255.100006103515625;
            vec4 _490;
            _490.y = _486 - (floor(_486 / 128.0) * 128.0);
            float _498 = _167.w * 255.100006103515625;
            _490.z = floor(_498 / 16.0);
            _490.w = _498 - (_490.z * 16.0);
            _490.y *= 0.00393700785934925079345703125;
            _490.z *= 0.02222222276031970977783203125;
            _490.w *= 0.01666666753590106964111328125;
            _490.x = 1.0 - ((_490.y + _490.z) + _490.w);
            for (uint _537 = 0u; _537 < 4u; _537++)
            {
                _439 += (_469._m0[(_444[_537] * 3u) + 0u] * _490[_537]);
            }
            for (uint _561 = 0u; _561 < 4u; _561++)
            {
                _440 += (_469._m0[(_444[_561] * 3u) + 1u] * _490[_561]);
            }
            for (uint _584 = 0u; _584 < 4u; _584++)
            {
                _441 += (_469._m0[(_444[_584] * 3u) + 2u] * _490[_584]);
            }
        }
        vec4 _607 = _437;
        vec4 _609 = _439;
        _44.x = _22(_607, _609);
        vec4 _613 = _437;
        vec4 _615 = _440;
        _44.y = _22(_613, _615);
        vec4 _619 = _437;
        vec4 _621 = _441;
        _44.z = _22(_619, _621);
        _44.w = 1.0;
        vec4 _626 = _166;
        vec4 _628 = _626;
        vec4 _630 = _439;
        _166.x = _18(_628, _630);
        vec4 _634 = _626;
        vec4 _636 = _440;
        _166.y = _18(_634, _636);
        vec4 _640 = _626;
        vec4 _642 = _441;
        _166.z = _18(_640, _642);
        vec4 _646 = _173;
        vec4 _648 = _646;
        vec4 _650 = _439;
        _173.x = _18(_648, _650);
        vec4 _654 = _646;
        vec4 _656 = _440;
        _173.y = _18(_654, _656);
        vec4 _660 = _646;
        vec4 _662 = _441;
        _173.z = _18(_660, _662);
    }
    vec3 _674 = cross(_166.xyz, _173.xyz) * _173.w;
    vec4 _666;
    _666 = vec4(_674.x, _674.y, _674.z, _666.w);
    _666.w = 0.0;
    vec4 _678 = _683._m0[_73._m1]._m0;
    vec4 _688 = _683._m0[_73._m1]._m1;
    vec4 _693 = _683._m0[_73._m1]._m2;
    vec4 _698 = _683._m0[_73._m1]._m3;
    vec4 _707 = _44;
    vec4 _709 = _678;
    gl_Position.x = _22(_707, _709);
    vec4 _714 = _44;
    vec4 _716 = _688;
    gl_Position.y = _22(_714, _716);
    vec4 _720 = _44;
    vec4 _722 = _693;
    gl_Position.z = _22(_720, _722);
    vec4 _726 = _44;
    vec4 _728 = _698;
    gl_Position.w = _22(_726, _728);
    vec4 _733 = _173;
    vec4 _735 = _250._m5;
    _732.x = _18(_733, _735);
    vec4 _740 = _666;
    vec4 _742 = _250._m5;
    _732.y = _18(_740, _742);
    vec4 _747 = _166;
    vec4 _749 = _250._m5;
    _732.z = _18(_747, _749);
    _732.w = _430;
    vec4 _757 = _173;
    vec4 _759 = _250._m6;
    _756.x = _18(_757, _759);
    vec4 _764 = _666;
    vec4 _766 = _250._m6;
    _756.y = _18(_764, _766);
    vec4 _771 = _166;
    vec4 _773 = _250._m6;
    _756.z = _18(_771, _773);
    _756.w = 0.0;
    vec4 _780 = _173;
    vec4 _782 = _250._m7;
    _779.x = _18(_780, _782);
    vec4 _787 = _666;
    vec4 _789 = _250._m7;
    _779.y = _18(_787, _789);
    vec4 _794 = _166;
    vec4 _796 = _250._m7;
    _779.z = _18(_794, _796);
    _779.w = 0.0;
    vec4 _803 = _44;
    vec4 _805 = _250._m5;
    vec4 _802;
    _802.x = _22(_803, _805);
    vec4 _810 = _44;
    vec4 _812 = _250._m6;
    _802.y = _22(_810, _812);
    vec4 _817 = _44;
    vec4 _819 = _250._m7;
    _802.z = _22(_817, _819);
    _802.w = 1.0;
    _825 = _802 - _199._m2;
    vec4 _830 = vec4(_832, _834);
    _841 = _830 + _58._m6;
    vec3 _846 = _825.xyz + _199._m2.xyz;
    _853 = vec4(0.0);
    _854 = vec4(0.0);
    _855 = vec4(0.0);
    float _856 = float(_199._m3.x > 0.0);
    float _861 = _199._m3.x * _250._m16.x;
    bool _870 = _199._m3.y > 0.0;
    bool _877;
    if (!_870)
    {
        _877 = _199._m3.z > 0.0;
    }
    else
    {
        _877 = _870;
    }
    bool _884;
    if (!_877)
    {
        _884 = _199._m3.w > 0.0;
    }
    else
    {
        _884 = _877;
    }
    float _867 = float(_884);
    vec3 _886 = vec3(0.579999983310699462890625) * _199._m3.yzw;
    _853 = vec4(_199._m3.y, _199._m3.z, _199._m3.w, _886.x);
    _854 = vec4(_886.y, _886.z, _886.x, _886.y);
    _855 = vec4(_886.z, _886.x, _886.y, _886.z);
    if ((_856 > 0.0) && (_867 <= 0.0))
    {
        float _927 = -4096.0;
        float _929 = 4096.0;
        float _931 = 256.0;
        float _933 = 256.0;
        float _934 = 6.0;
        float _936 = 256.0;
        float _937 = 256.0;
        float _938 = 24.0;
        vec3 _940 = vec3(1.0 / _936, 1.0 / _937, 1.0 / _938);
        vec3 _948 = vec3(2.0 / _936, 2.0 / _937, 2.0 / _938);
        vec3 _956 = vec3(1.0 / _931, 1.0 / _933, 1.0 / _934);
        float _964 = 1.0 / (_929 - _927);
        vec3 _976 = (_846 - vec3(_927)) * _964;
        vec3 _969 = _11(_976);
        vec4 _978 = vec4(0.0);
        uvec3 _980 = uvec3(0u);
        for (uint _982 = 0u; _982 < 13u; _982++)
        {
            vec3 _991 = vec3(0.5) + floor(vec3(2.0) * _969);
            vec4 _998 = vec4(_956 * (vec3(_980) + _991), 0.0);
            _978 = textureLod(_1012, _998.xyz, _998.w);
            _969 = fract(_969 * vec3(2.0));
            _980 = uvec3(_978.zyx * vec3(255.0));
            if (_978.w > 0.0)
            {
                break;
            }
        }
        uint _1035 = (((uint(_978.w * 255.0) << uint(24)) | (uint(_978.z * 255.0) << uint(16))) | (uint(_978.y * 255.0) << uint(8))) | uint(_978.x * 255.0);
        uvec3 _1059 = uvec3((_1035 >> uint(19)) & 4095u, (_1035 >> uint(7)) & 4095u, _1035 & 127u);
        vec3 _1072 = vec3(2.0) * ((_969 * vec3(0.5)) + vec3(0.25));
        vec4 _1078 = vec4(_940 * (vec3(_1059) + _1072), 0.0);
        vec4 _1089 = textureLod(_1090, vec4(_1078.xy, _1078.z + (_948.z * 0.0), 0.0).xyz, vec4(_1078.xy, _1078.z + (_948.z * 0.0), 0.0).w) * _861;
        vec4 _1119 = textureLod(_1090, vec4(_1078.xy, _1078.z + (_948.z * 1.0), 0.0).xyz, vec4(_1078.xy, _1078.z + (_948.z * 1.0), 0.0).w) * _861;
        vec4 _1148 = textureLod(_1090, vec4(_1078.xy, _1078.z + (_948.z * 2.0), 0.0).xyz, vec4(_1078.xy, _1078.z + (_948.z * 2.0), 0.0).w) * _861;
        _853 = vec4(_1089.x, _1119.x, _1148.x, _1089.y);
        _854 = vec4(_1119.y, _1148.y, _1089.z, _1119.z);
        _855 = vec4(_1148.z, _1089.w, _1119.w, _1148.w);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}




