
// Mounted Turrets
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _20
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 1, std430) restrict readonly buffer _22_24
{
    _20 _m0[];
} _24;

layout(set = 2, binding = 0, std140) uniform _66_68
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _68;

layout(set = 0, binding = 0, std140) uniform _79_81
{
    vec4 _m0;
    vec4 _m1;
} _81;

layout(set = 1, binding = 0, std140) uniform _134_136
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _136;

layout(set = 0, binding = 2, std430) restrict readonly buffer _355_357
{
    vec4 _m0[];
} _357;

layout(push_constant, std430) uniform _27_29
{
    int _m0;
    int _m1;
} _29;

layout(location = 0) in vec4 _56;
layout(location = 3) in vec4 _119;
layout(location = 9) in vec4 _375;
layout(location = 2) in vec4 _391;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    vec4 _19 = _24._m0[_29._m1]._m0;
    vec4 _37 = _24._m0[_29._m1]._m1;
    vec4 _42 = _24._m0[_29._m1]._m2;
    vec4 _48 = _24._m0[_29._m1]._m3;
    vec4 _54 = vec4(_56.xyz, 1.0);
    bool _76 = _68._m4.x != 0.0;
    bool _87;
    if (_76)
    {
        _87 = _81._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _87 = _76;
    }
    bool _94;
    if (_87)
    {
        _94 = _68._m5.x > 0.0;
    }
    else
    {
        _94 = _87;
    }
    if (_94)
    {
        vec3 _98 = vec3(_81._m0.xy, 0.0);
        float _107 = _68._m4.x;
        float _110 = _68._m4.y;
        float _114 = _68._m4.w;
        vec4 _118 = _119;
        float _121 = _68._m5.x;
        float _124 = _68._m5.y;
        float _127 = _68._m5.z;
        float _130 = _68._m5.w;
        vec4 _137 = _54;
        vec4 _139 = _136._m5;
        vec4 _133;
        _133.x = _12(_137, _139);
        vec4 _145 = _54;
        vec4 _147 = _136._m6;
        _133.y = _12(_145, _147);
        vec4 _153 = _54;
        vec4 _155 = _136._m7;
        _133.z = _12(_153, _155);
        _133.w = 1.0;
        float _161 = dot(_133.xyz, _98) * _121;
        float _168 = _118.z * _130;
        float _173 = _136._m5.w * _136._m6.w;
        float _179 = ((_81._m1.x * _68._m4.z) * _121) - _161;
        float _189 = (_118.x * 1.0) - _168;
        float _195 = sin(_179 - _189);
        float _200 = sin((_179 * 1.33000004291534423828125) - _189);
        float _207 = ((_195 + _200) * 0.25) + 0.5;
        _207 *= _207;
        float _218 = (_207 * (_110 - _107)) + _107;
        vec3 _226 = _98 * vec3(_218);
        float _231 = ((_118.y * 16.0) - _173) - _168;
        float _240 = sin(((_81._m1.x * 4.0) * _124) + _231);
        float _250 = cos(((_81._m1.x * 3.3299999237060546875) * _124) + _231);
        float _260 = (_240 + _250) * (-_118.w);
        vec3 _268 = vec3(_240 * _114, _250 * _114, _260 * _127) * vec3(_218);
        vec3 _282 = ((_226 + _268) * _81._m0.z) * _118.z;
        vec3 _295 = _133.xyz + _282;
        _133 = vec4(_295.x, _295.y, _295.z, _133.w);
        _133.w = 1.0;
        _54.x = dot(_133, _136._m13);
        _54.y = dot(_133, _136._m14);
        _54.z = dot(_133, _136._m15);
    }
    if (_68._m8.z != 0.0)
    {
        vec4 _323 = _54;
        vec4 _325 = vec4(0.0);
        vec4 _327 = vec4(0.0);
        vec4 _328 = vec4(0.0);
        uvec4 _331 = uvec4(uint(_136._m21.x + _68._m8.x)) + uvec4(_119 * 255.0);
        if (_68._m8.z == 1.0)
        {
            uint _351 = _331.x;
            _325 = _357._m0[(_351 * 3u) + 0u];
            _327 = _357._m0[(_351 * 3u) + 1u];
            _328 = _357._m0[(_351 * 3u) + 2u];
        }
        else
        {
            float _374 = _375.w * 255.100006103515625;
            vec4 _381;
            _381.y = _374 - (floor(_374 / 128.0) * 128.0);
            float _390 = _391.w * 255.100006103515625;
            _381.z = floor(_390 / 16.0);
            _381.w = _390 - (_381.z * 16.0);
            _381.y *= 0.00393700785934925079345703125;
            _381.z *= 0.02222222276031970977783203125;
            _381.w *= 0.01666666753590106964111328125;
            _381.x = 1.0 - ((_381.y + _381.z) + _381.w);
            for (uint _430 = 0u; _430 < 4u; _430++)
            {
                _325 += (_357._m0[(_331[_430] * 3u) + 0u] * _381[_430]);
            }
            for (uint _454 = 0u; _454 < 4u; _454++)
            {
                _327 += (_357._m0[(_331[_454] * 3u) + 1u] * _381[_454]);
            }
            for (uint _477 = 0u; _477 < 4u; _477++)
            {
                _328 += (_357._m0[(_331[_477] * 3u) + 2u] * _381[_477]);
            }
        }
        vec4 _500 = _323;
        vec4 _502 = _325;
        _54.x = _12(_500, _502);
        vec4 _506 = _323;
        vec4 _508 = _327;
        _54.y = _12(_506, _508);
        vec4 _512 = _323;
        vec4 _514 = _328;
        _54.z = _12(_512, _514);
        _54.w = 1.0;
    }
    vec4 _523 = _54;
    vec4 _525 = _19;
    gl_Position.x = _12(_523, _525);
    vec4 _530 = _54;
    vec4 _532 = _37;
    gl_Position.y = _12(_530, _532);
    vec4 _536 = _54;
    vec4 _538 = _42;
    gl_Position.z = _12(_536, _538);
    vec4 _542 = _54;
    vec4 _544 = _48;
    gl_Position.w = _12(_542, _544);
    gl_Position.y = -gl_Position.y;

  // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


