// Light FLARES position 
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _158_160
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _160;

layout(set = 2, binding = 0, std140) uniform _165_167
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _167;

layout(set = 0, binding = 0, std140) uniform _176_178
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _178;

layout(push_constant, std430) uniform _353_355
{
    int _m0;
    int _m1;
} _355;

layout(set = 0, binding = 1) uniform sampler2D _282;
layout(set = 2, binding = 1) uniform sampler2D _356;
layout(set = 2, binding = 2) uniform sampler2D _357;

layout(location = 0) in vec4 _111;
layout(location = 13) in uvec4 _130;
layout(location = 2) out vec4 _142;
layout(location = 1) in vec2 _144;
layout(location = 0) out vec4 _153;
layout(location = 3) in vec4 _154;
layout(location = 12) in vec2 _196;

float _13(float _12)
{
    return _12 * ((_12 * ((_12 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _19(vec3 _18)
{
    float _56 = _18.x;
    vec3 _55;
    _55.x = _13(_56);
    float _63 = _18.y;
    _55.y = _13(_63);
    float _69 = _18.z;
    _55.z = _13(_69);
    return _55;
}

vec4 _25(vec4 _24)
{
    vec3 _79 = _24.xyz;
    vec4 _78 = vec4(_19(_79), 1.0);
    float _87 = _24.w;
    _78.w = _13(_87);
    return _78;
}

float _34(float _30, vec4 _31, float _32, bool _33)
{
    float _96 = _31.w / (_30 + _31.z);
    return _96 * _32;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _109 = vec4(_111.xy, 0.0, 1.0);
    gl_Position = _109;
    // Position
    gl_Position.x +=vk3d_params[VIEW].stereo.x * (1.0 - _178._m3.z * vk3d_params[VIEW].stereo.y) * 0.95 ;
     float _127 = float(_130.x) / 256.0;
    float _137 = float(_130.y) / 256.0;
    _142 = _144.xyxy;
    vec2 _150 = vec2(1.0) - _142.yw;
    _142 = vec4(_142.x, _150.x, _142.z, _150.y);
    vec4 _155 = _154;
    _153 = ((((_25(_155) * _160._m0) * _167._m0.x) * _160._m1.x) * vec4(_178._m0.xxx, 1.0)) * vec4(vec3(_127), 1.0);
    vec2 _195 = (_196 * 0.5) + vec2(0.5); 
    _195.y = 1.0 - _195.y;
    _195 *= _178._m1.xy;
    float _214 = _111.z;
    vec4 _218 = _178._m2;
    float _221 = 1.0;
    bool _222 = true;
    float _211 = _34(_214, _218, _221, _222) - _137;
    int _227 = 3;
    float _229 = 1.0 / float(((_227 * 2) + 1) * ((_227 * 2) + 1));
    float _239 = 0.0;
    
    
    for (int _240 = -_227; _240 <= _227; _240++)
    {
        for (int _251 = -_227; _251 <= _227; _251++)
        {
            float temp  = +_251;
            //temp.x += vk3d_params[VIEW].stereo.x * 1000;
            vec2 pos = vec2(float(temp), float(_240)) * _178._m3.zw;
            vec2 _262 = (pos * _178._m1.xy) + _195;
            float _278 = textureLod(_282, vec4(_262, 0.0, 0.0).xy, vec4(_262, 0.0, 0.0).w).x;
            float _297 = _278;
            vec4 _299 = _178._m2;
            float _302 = 1.0;
            bool _303 = true;
            float _296 = _34(_297, _299, _302, _303);
            // Flares Occlusion compute
            _239 += ((_296 > _211) ? _229 : 0.0);
            //_239 += _229 * 0.5;
        }
    }
    float _316 = _239;
    _153.w *= _10(_316);
    if (true)
    {
        float _326 = 0.0039215688593685626983642578125;
        float _328 = 1.0 / (1.0 - _326);
        if (_153.w < _326)
        {
            gl_Position = vec4(vec3(0.0).x, vec3(0.0).y, vec3(0.0).z, gl_Position.w);
        }
        _153.w = (_153.w - _326) * _328;
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x += vk3d_params[VIEW].stereo.x * (1.0 - gl_Position.z * vk3d_params[VIEW].stereo.y);
}




















